Option Strict On
Module Module1
    Function f(ByVal x As Double) As Double
        Return Math.Exp(-x) - x
    End Function
    Sub Main()
        Dim a As Double = 0
        Dim b As Double = 1
        Dim c As Double
        Dim eps As Double = 0.000001
        Do While Math.Abs(b - a) > 2 * eps
            c = (a + b) / 2
            If f(a) * f(c) < 0 Then
                'Для решения уравнения методом дихотомии можно использовать более простую запись, вот она.
                b = c
            Else
                a = c
            End If
            If f(a) <> f(a) _
            Or f(b) <> f(b) _
            Or Math.Sign(f(a)) = Math.Sign(f(b)) Then
                Console.WriteLine("!!!ОШИБКА")
            End If
        Loop

        Console.WriteLine("Решение:  x={0}", c)
        Console.ReadLine()
    End Sub

End Module
